% \documentclass[noanswers, nolegalese, 11pt]{examjh}
\documentclass[answers, nolegalese, 11pt]{examjh}
\usepackage{../../../../computingfonts}
\usepackage{../../../../contentmacros}

\setlength{\parindent}{0em}\setlength{\parskip}{0.5ex}
\pagestyle{empty}
\begin{document}\thispagestyle{empty}
\makebox[\textwidth]{Questions for Two.III\hfill  From \textit{Theory of Computation}, by Hef{}feron}\vspace{-1ex}
\makebox[\textwidth]{\hbox{}\hrulefill\hbox{}}


\begin{questions}
\question 
We will walk through the diagonalization argument.
\begin{parts}
\part
Make up numbers to fill in the entries of this array
(besides the column before the decimal, put in five columns after).
\begin{equation*} \setlength{\arraycolsep}{1.5\arraycolsep}
  \begin{array}{c|r@{\hspace*{.35em}.\hspace*{.35em}}ccccccc@{\hspace*{1em}\ldots\;}}
    \multicolumn{1}{c}{\text{\small $n$\hspace*{0.25em}}} 
    &\multicolumn{8}{c}{\text{\hspace*{-1.00em}\small\tabulartext{Decimal expansion of $f(n)$}\ }}  \\ 
   \cline{1-9}
   \rule{0em}{2.15ex}% bit more vertical room 
   0  &    &   &   &   &   &   &   &   \\  
   1  &    &   &   &   &   &   &   &   \\  
   2  &    &   &   &   &   &   &   &   \\  
   3  &     &  &    &   &   &   &   &   \\  
   4  &    &   &   &   &   &   &   &   \\
   5  &    &    &   &   &   &   &   &   \\[-.5ex]
   \multicolumn{1}{c}{\vdotswithin{$0$}} 
    &\multicolumn{4}{c}{\vdotswithin{$1$}}  
  \end{array}
\end{equation*}
\begin{solution}
Here is one way to fill them in.
\begin{equation*} \setlength{\arraycolsep}{1.5\arraycolsep}
  \begin{array}{c|r@{\hspace*{.35em}.\hspace*{.35em}}ccccccc@{\hspace*{1em}\ldots\;}}
    \multicolumn{1}{c}{\text{\small $n$\hspace*{0.25em}}} 
    &\multicolumn{8}{c}{\text{\hspace*{-1.00em}\small\tabulartext{Decimal expansion of $f(n)$}\ }}  \\ 
   \cline{1-9}
   \rule{0em}{2.15ex}% bit more vertical room 
   0  &5    &2   &4   &9   &0   &1   &7   &7   \\  
   1  &-3    &0   &0   &0   &0   &0   &0   &0   \\  
   2  &0    &2   &5   &0   &0   &0   &0   &0   \\  
   3  &0     &1  &4    &1   &5   &9   &2   &7   \\  
   4  &2    &1   &4   &1   &4   &1   &4   &1   \\
   5  &-1    &0    &1   &0   &0   &1   &0   &0   \\[-.5ex]
   \multicolumn{1}{c}{\vdotswithin{$0$}} 
    &\multicolumn{4}{c}{\vdotswithin{$1$}}  
  \end{array}
\end{equation*}
\end{solution}

\part List the entries on the diagonal to the right of the decimal point.
That is,  where the digit in the $j$-th decimal place
is $f(i)[j]$,
list $f(i)[i]$ for each row~$i$ shown.
\begin{solution}
For the above table, these are the digits.
\begin{equation*}
\begin{array}{r|*{6}{c}}
  i        &0  &1  &2  &3  &4  &5   \\
  \cline{2-7}
  f(i)[i]  &2  &0  &0  &5  &1  &0   \\
\end{array}
\end{equation*}
\end{solution}


\part To that sequence, apply this transformation.
\begin{equation*}
  g(x)=
  \begin{cases}
    2  &\case{if $x=1$}  \\
    1  &\case{otherwise}
  \end{cases}
\end{equation*}
\begin{solution}
\begin{equation*}
\begin{array}{r|*{6}{c}}
  i           &0  &1  &2  &3  &4  &5   \\
  \cline{2-7}
  f(i)[i]     &2  &0  &0  &5  &1  &0   \\
  \cline{2-7}
  g(f(i)[i])  &1  &1  &1  &1  &2  &1   \\
\end{array}
\end{equation*}
\end{solution}

\part
Produce the number $z=0.\;\ldots\;$ whose $x$-th decimal place is 
$g(f(x)[x])$.
Observe that $z$ is not on any row.
\begin{solution}
$z=0.111\,121\,\ldots$
\end{solution}

\end{parts}


\question
Let $S=\set{0,1,2,3}$.  
\begin{parts}
\part
List all of the subsets $A\subseteq S$.
\begin{solution}
The most systemmatic way is to use the binary numbers.
\begin{equation*}
\begin{array}{l|r|c}
  \multicolumn{1}{c}{\text{\textit{Set number $n$}}}
  &\multicolumn{1}{c}{\text{\textit{Binary for $n$}}}
  &\multicolumn{1}{c}{\text{\textit{Set}}}      \\
  \hline
  0  &0000  &\set{}  \\
  1  &0001  &\set{0}  \\
  2  &0010  &\set{1}  \\
  3  &0011  &\set{0,1}  \\[0.75ex]
  4  &0100  &\set{2}  \\
  5  &0101  &\set{2,0}  \\
  6  &0110  &\set{2,1}  \\
  7  &0111  &\set{2,1,0}  \\[0.75ex]
  8  &1000  &\set{3}  \\
  9  &1001  &\set{3,0}  \\
  10 &1010  &\set{3,1}  \\
  11 &1011  &\set{3,1,0}  \\[0.75ex]
  12 &1100  &\set{3,2}  \\
  13 &1101  &\set{3,2,0}  \\
  14 &1110  &\set{3,2,1}  \\
  15 &1111  &\set{3,2,1,0}  \\  
\end{array}
\end{equation*}

\end{solution}

\part
Pick out four different subsets.
That is, define a one-to-one map $\map{f}{S}{\powerset(S)}$.
\begin{center}
\begin{tabular}{r|*{4}{c@{\hspace{3em}}}}
  $s$    &$0$ &$1$ &$2$ &$3$   \\
  \cline{2-5}
  $f(s)$ &&&&   \\
\end{tabular}
\end{center}
\begin{solution}
These are four different subsets.
\begin{center}
\begin{tabular}{r|*{4}{c@{\hspace{3em}}}}
  $s$    &$0$ &$1$ &$2$ &$3$   \\
  \cline{2-5}
  $f(s)$ &$\set{3,1}$ &$\set{2,1,0}$ &$\set{0}$ &$\set{3,2,1,0}$   \\
\end{tabular}
\end{center}
\end{solution}

\part
For those four sets~$A$, 
list the characteristic functions $\map{\charfcn{A}}{S}{\set{0,1}}$.
\begin{solution}
This is the characteristic function of $f(0)=\set{3,1}$.
\begin{equation*}
\begin{array}{r|*{4}{c}}
   s\in S         &3 &2 &1 &0   \\
   \cline{2-5}
   \charfcn{A}(s) &1 &0 &1 &0   \\
\end{array}
\end{equation*}
This is the characteristic function of $f(1)=\set{2,1,0}$.
\begin{equation*}
\begin{array}{r|*{4}{c}}
   s\in S         &3 &2 &1 &0   \\
   \cline{2-5}
   \charfcn{A}(s) &0 &1 &1 &1   \\
\end{array}
\end{equation*}
This is the characteristic function of $f(2)=\set{0}$.
\begin{equation*}
\begin{array}{r|*{4}{c}}
   s\in S         &3 &2 &1 &0   \\
   \cline{2-5}
   \charfcn{A}(s) &0 &0 &0 &1   \\
\end{array}
\end{equation*}
This is the characteristic function of $f(3)=\set{3,2,1,0}$.
\begin{equation*}
\begin{array}{r|*{4}{c}}
   s\in S         &3 &2 &1 &0   \\
   \cline{2-5}
   \charfcn{A}(s) &1 &1 &1 &1   \\
\end{array}
\end{equation*}
(Note the relationship with the binary numbers given above.)
\end{solution}

\part
Fill in this table.
\begin{center}
\begin{tabular}{c|*{4}{c}}
  \multicolumn{1}{c}{$s\in S$}
    &$\charfcn{f(s)}(0)$
    &$\charfcn{f(s)}(1)$
    &$\charfcn{f(s)}(2)$
    &$\charfcn{f(s)}(3)$  \\
  \hline
  $0$  &$$ &$$ &$$ &$$ \\
  $1$  &$$ &$$ &$$ &$$ \\
  $2$  &$$ &$$ &$$ &$$ \\
  $3$  &$$ &$$ &$$ &$$ \\
\end{tabular}
\end{center}
\begin{solution}
\begin{center}
\begin{tabular}{c|*{4}{c}}
  \multicolumn{1}{c}{$s\in S$}
    &$\charfcn{f(s)}(0)$
    &$\charfcn{f(s)}(1)$
    &$\charfcn{f(s)}(2)$
    &$\charfcn{f(s)}(3)$  \\
  \hline
  $0$  &$0$ &$1$ &$0$ &$1$ \\
  $1$  &$1$ &$1$ &$1$ &$0$ \\
  $2$  &$1$ &$0$ &$0$ &$0$ \\
  $3$  &$1$ &$1$ &$1$ &$1$ \\
\end{tabular}
\end{center}
\end{solution}

\part
Find $R=\set{s\suchthat s\notin f(s)}$.
Observe that it just involves flipping the diagonal bits on the table above.
Observe also that $R\neq f(i)$ for $i\in S$.
\begin{solution}
Recall that 
\begin{center}
\begin{tabular}{r|*{4}{c@{\hspace{3em}}}}
  $s$    &$0$ &$1$ &$2$ &$3$   \\
  \cline{2-5}
  $f(s)$ &$\set{3,1}$ &$\set{2,1,0}$ &$\set{0}$ &$\set{3,2,1,0}$   \\
\end{tabular}
\end{center}
so $0\notin f(0)$, and $1\in f(1)$, and $2\notin f(2)$, and $3\in f(3)$.
That is, $R=\set{0,2}$.
It is indeed not one of the four sets.
\end{solution}
\end{parts}

\end{questions}
\end{document}
